"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
var Parser = require("../../utils/fileParser/index");
var path = require("path");
var charts = require("../../utils/charts/index");
var datas = Parser.read_csv(path.join(__dirname, '../../../assets/testSet.txt'), {
    index_col: false,
    delimiter: ',',
    header: false,
    classType: 'string'
});
var dataSet = datas.drop(4).values;
var labels = datas.getClasses();
labels = labels.map(function (v) {
    return v === 'Iris-setosa' ? 1 : 0;
});
var logi = new index_1.default(dataSet, labels, 150);
var errors = 0;
for (var i = 0; i < dataSet.length; i++) {
    var r = logi.classify(dataSet[i]);
    if (labels[i] !== r) {
        errors += 1;
    }
}
console.log('error rate:', errors / dataSet.length);
var weights = logi.getWeights();
console.log(weights);
charts.drawLogistic(dataSet, labels, weights);
//# sourceMappingURL=../../maps/algorithm/logistic/test.js.map
